
public class StackWithArray {
    
    private int items = 0; // number of items in the stack

    private int[] array = new int[10];

    public void push(int data) {
        if (items >= array.length) {

            // array is full. Create a new array twice the initial size
            int[] newArray = new int[2 * array.length];
            
            // Copy contents to the new array
            copyTo(array, newArray, array.length);
            array = newArray;
            
            push(data);
            
        } else {
            this.array[items] = data;
            items++;
        }
    }

    private void copyTo(int[] source, int[] dest, int size) {
        for (int i = 0; i < size; i++) {
              dest[i] = source[i];
        }
    }
}
